/***********************************************************************
**      COM- TrComPort.dll
** $Author: trainer $
** $Revision: 1.2 $
** $Version: NONE $
** $Copyright    1991-2003 trainer  ALL RIGHTS RESERVED. $
** $Date: 10  2003 . 22:45:50 $
***********************************************************************/
#ifndef TrComPort_H
/*=========================================================================*/
#define TrComPort_H
#include <windows.h>
/*-------------------------------------------------------------------------*/
#define DLLFUNC __declspec(dllimport)
/*-------------------------------------------------------------------------*/
#ifndef TRCOM_ERR_NUMBER
#define TRCOMERR_NONE             0
#define TRCOM_FAILED(value)       ((value)<0)
#define TRCOM_SUCCEEDED(value)    ((value)>=0)
//   (  )
#define TRCOMERR_UNKNOWN          ((INT)-1)
//   ( )
#define TRCOMERR_CREATE           ((INT)-2)
//    
#define TRCOMERR_EVENT            ((INT)-3)
//      
#define TRCOMERR_GET_CONFIG       ((INT)-4)
//     
#define TRCOMERR_SET_CONFIG       ((INT)-5)
//     
#define TRCOMERR_GET_CONTROL      ((INT)-6)
//     
#define TRCOMERR_SET_CONTROL      ((INT)-7)
//    
#define TRCOMERR_READ             ((INT)-8)
//    
#define TRCOMERR_WRITE            ((INT)-9)
//     -  
#define TRCOMERR_READ_TIMEOUT     ((INT)-10)
//     -  
#define TRCOMERR_WRITE_TIMEOUT    ((INT)-11)
//     -  
#define TRCOMERR_READ_ABORTED     ((INT)-12)
//     -  
#define TRCOMERR_WRITE_ABORTED    ((INT)-13)
//    
#define TRCOMERR_PURGE            ((INT)-14)
//     -  
#define TRCOMERR_PURGE_ABORTED    ((INT)-15)
//     
#define TRCOMERR_QUEUE            ((INT)-16)
//  
#define TRCOMERR_INVALID_HANDLE   ((INT)-17)
//   
#define TRCOMERR_NOT_CONNECTED    ((INT)-18)
//   
#define TRCOMERR_INVALID_ARGUMENT ((INT)-19)
//    
#define TRCOMERR_BREAK            ((INT)-20)
//      (CRC  ..)
#define TRCOMERR_CHECKINFO        ((INT)-21)
//   
#define TRCOMERR_REJECTED         ((INT)-22)
//       
#define TRCOMERR_INSUFFICIENT_BUFFER ((INT)-23)
//     
#define TRCOMERR_ECHO             ((INT)-24)
//  ,  ,   
#define TRCOMERR_RESPONCE_DATA    ((INT)-25)
//   
#define TRCOMERR_NOT_FOUND        ((INT)-26)
//   
#define TRCOMERR_WRONG_DEV_VERSION ((INT)-27)
//     
#define TRCOMERR_RESOURCE         ((INT)-28)
//  
#define TRCOMERR_ANSWER           ((INT)-29)
//   
#define TRCOMERR_FAILED           ((INT)-30)
//   -  -
#define TRCOMERR_TIMED_OUT        ((INT)-31)
//  
#define TRCOMERR_ABORTED          ((INT)-32)
//  
#define TRCOMERR_BUSY             ((INT)-33)
//   
#define TRCOMERR_NOT_INITIALIZED  ((INT)-34)
//     -  
#define TRCOMERR_ACCEPTOR_BLOCKED ((INT)-35)
//   -     
#define TRCOMERR_SERVICE_CORRUPTED ((INT)-36)
//   -   
#define TRCOMERR_INCOMPATIBLE_VERSION ((INT)-37)
//    -  
#define TRCOMERR_SERVICE_REINITIALIZE ((INT)-38)
//     
#define TRCOMERR_INVALID_MEDIA_STATE ((INT)-39)
//     
#define TRCOMERR_UNAVAILABLE_VALUE ((INT)-40)
//   ()
#define TRCOMERR_COMMUNICATION_LOCKED ((INT)-41)
//   (  )
#define TRCOMERR_ALREADY_IN_USE   ((INT)-42)
//   / 
#define TRCOMERR_NO_DEVICE        ((INT)-43)
//   (  )
#define TRCOMERR_INVALID_SIZE     ((INT)-44)
/*-------------------------------------------------------------------------*/
#define TRCOM_ERR_NUMBER       (-TRCOMERR_INVALID_SIZE)
#endif /* TRCOM_ERR_NUMBER */
/*-------------------------------------------------------------------------*/
#include <pshpack4.h>
/*-------------------------------------------------------------------------*/
typedef struct {
   DWORD DesiredParams;
   LONG  BaudRate;           /*                                      */
   LONG  DefaultTimeout;     /* -  ( )             */
   BYTE  ByteSize;           /*  (4-8)                                 */
   BYTE  StopBits;           /*  -
                                (ONESTOPBIT/ONE5STOPBITS/TWOSTOPBITS)              */
   BYTE  CheckParity;        /*  (0-,1-)                      */
   BYTE  Parity;             /*  
                            (NOPARITY/ODDPARITY/EVENPARITY/MARKPARITY/SPACEPARITY) */
   BYTE  RtsControl;         /*   RTS(. RTS_CONTROL_) */
   BYTE  DtrControl;         /*   DTR(. DTR_CONTROL_) */
} TrComPortParameters, *PTrComPortParameters;
/*  / ,    */
typedef enum {
   tcpmpBaudRate=1,          /*              */
   tcpmpDefaultTimeout=2,    /* -        */
   tcpmpByteSize=4,          /*                */
   tcpmpStopBits=8,          /*  -        */
   tcpmpCheckParity=16,      /*            */
   tcpmpParity=32,           /*            */
   tcpmpEnableRtsControl=64, /*   RTS    */
   tcpmpEnableDtrControl=128,/*   DTR    */
   tcpmpClearHidden=65536    /*     */
} TrComPortModifiedParams;
/*---------------------------------------------------------------------------
    /,    */
typedef enum {
   tcpffRxAbort = 1,
   tcpffTxAbort = 2,
   tcpffRxClear = 4,
   tcpffTxClear = 8
} TrComPortFlushFlags;
/*-------------------------------------------------------------------------*/
typedef enum {
   tcpscfChangeRtsState = 1,
   tcpscfChangeRtsFlag  = 2,
   tcpscfClearRts       = 2,
   tcpscfSetRts         = 3,
   tcpscfChangeDtrState = 4,
   tcpscfChangeDtrFlag  = 8,
   tcpscfClearDtr       = 8,
   tcpscfSetDtr         = 12
} TrComPortSetControlFlags;
/*-------------------------------------------------------------------------*/
#include <poppack.h>
/*-------------------------------------------------------------------------*/
#ifndef _BY_REF
 #ifdef __cplusplus
  #define _BY_REF &
 #else
  #define _BY_REF *
 #endif /* __cplusplus */
#endif /* _BY_REF */
/*-------------------------------------------------------------------------*/
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
/*-------------------------------------------------------------------------
  COM-
  portnum -   ( 0-COM1, 1-COM2,..7-COM8 )
       */

DLLFUNC
INT
WINAPI
TrComPortOpen(INT portnum);
/*---------------------------------------------------------------------------
  
  portid -  (   TrComPortOpen ) */

DLLFUNC
INT
WINAPI
TrComPortClose(INT portid);
/*---------------------------------------------------------------------------
   
  portid     -  (   TrComPortOpen )
  parameters - ,    */

DLLFUNC
INT
WINAPI
TrComPortSetConfig(INT portid, PTrComPortParameters parameters);
/*---------------------------------------------------------------------------
   
  portid     -  (   TrComPortOpen )
  parameters - ,    */

DLLFUNC
INT
WINAPI
TrComPortGetConfig(INT portid, PTrComPortParameters parameters);
/*---------------------------------------------------------------------------
    
  portid  -  (   TrComPortOpen )
  timeout - -  ( -1 -     )
      */

DLLFUNC
INT
WINAPI
TrComPortReadByte(INT portid, LONG timeout);
/*---------------------------------------------------------------------------
     
  portid  -  (   TrComPortOpen )
  buffer  -  
  length  -  
  timeout - -  ( -1 -     ) */

DLLFUNC
INT
WINAPI
TrComPortReadArray(INT portid, LPVOID buffer, DWORD length, LONG timeout);
/*---------------------------------------------------------------------------
    
  portid  -  (   TrComPortOpen )
  value   -  
  timeout - -  ( -1 -     ) */

DLLFUNC
INT
WINAPI
TrComPortWriteByte(INT portid, BYTE value, LONG timeout);
/*---------------------------------------------------------------------------
     
  portid  -  (   TrComPortOpen )
  buffer  -  
  length  -  
  timeout - -  ( -1 -     ) */

DLLFUNC
INT
WINAPI
TrComPortWriteArray(INT portid, LPVOID buffer, DWORD length, LONG timeout);
/*---------------------------------------------------------------------------
          
  portid        -  (   TrComPortOpen )
  write_buffer  -   
  write_length  -   
  read_buffer   -   
  read_length   -   
  timeout       - -  /( -1 -     ) */

DLLFUNC
INT
WINAPI
TrComPortWriteAndRead(INT portid, LPVOID write_buffer, DWORD write_length, LPVOID read_buffer, DWORD read_length, LONG timeout);
/*---------------------------------------------------------------------------
  (    )
  portid  -  (   TrComPortOpen ) */

DLLFUNC
INT
WINAPI
TrComPortBreak(INT portid);
/*---------------------------------------------------------------------------
   
  portid  -  (   TrComPortOpen )
  action  -   */

DLLFUNC
INT
WINAPI
TrComPortPurge(INT portid, DWORD action);
/*---------------------------------------------------------------------------
    
  portid  -  (   TrComPortOpen )
  value   -     */

DLLFUNC
INT
WINAPI
TrComPortSetControl(INT portid, DWORD action);
/*---------------------------------------------------------------------------
    
  portid  -  (   TrComPortOpen )
  value   -     */

DLLFUNC
INT
WINAPI
TrComPortGetControl(INT portid, DWORD _BY_REF value);
/*---------------------------------------------------------------------------
          
  portid       -  (   TrComPortOpen )
  input_queue  -       
                ( NULL,     )
  output_queue -       
                ( NULL,     ) */

DLLFUNC
INT
WINAPI
TrComPortGetQueue(INT portid, LPDWORD input_queue, LPDWORD output_queue);
/*-------------------------------------------------------------------------*/
#ifdef __cplusplus
}
#endif /* __cplusplus */
#undef DLLFUNC
/*=========================================================================*/
#endif /* TrComPort.h */
